﻿// Keep this lines for a best effort IntelliSense of Visual Studio 2017.
/// <reference path="C:\TwinCAT\Functions\TE2000-HMI-Engineering\Infrastructure\TcHmiFramework\Latest\Lib\jquery.d.ts" />
/// <reference path="C:\TwinCAT\Functions\TE2000-HMI-Engineering\Infrastructure\TcHmiFramework\Latest\TcHmi.d.ts" />
/// <reference path="C:\TwinCAT\Functions\TE2000-HMI-Engineering\Infrastructure\TcHmiFramework\Latest\Controls\System\TcHmiControl\Source.d.ts" />

// Keep this lines for a best effort IntelliSense of Visual Studio 2013/2015.
/// <reference path="C:\TwinCAT\Functions\TE2000-HMI-Engineering\Infrastructure\TcHmiFramework\Latest\Lib\jquery\jquery.js" />
/// <reference path="C:\TwinCAT\Functions\TE2000-HMI-Engineering\Infrastructure\TcHmiFramework\Latest\TcHmi.js" />

(function (TcHmi) {

    var isFocused = function () {

        // get function is mobile
        var isMobile = TcHmi.Functions.getFunction('isMobile');

        // check if we are on a mobile device
        if (isMobile) {
            if (isMobile.any()) {
                return false;
            }
        }

        //getting the focused element
        var myActiveElement = document.activeElement;

        if (myActiveElement === undefined || myActiveElement === null)
            return false;

        //getting the class of the element
        var myAttribute = myActiveElement.getAttribute('class');
        
        if (myAttribute) {
            //Check if the element is a textbox
            if (myAttribute === "tchmi-textbox-template-input" || myAttribute === "tchmi-combobox-template-input") {
                return true;
            } 
        } else {            
            // element is not a textbox or combobox
            // get type of the element
            var myType = myActiveElement.getAttribute('type');
            //Check if the element is a Datagrid input cell
            if (myType === "text") {
                return true;
            }
        }

        return false;
    };

    
    TcHmi.Functions.registerFunction('isFocused', isFocused);
})(TcHmi);